;- - - - - - - - - - - - - - - - - - - - - - - - -
;	BUFFERIZATION
;- - - - - - - - - - - - - - - - - - - - - - - - -
Graphics3D 800,600,16,0
SetBuffer BackBuffer()
;- - - - - - - - - - - - - - - - - - - - - - - - -
;	GLOBALIZATOR
;- - - - - - - - - - - - - - - - - - - - - - - - -
Global pl
Global G#=-0.3
Global jump#
Global xmov
Global cloud1
Global cloud2
Global cloud3
Global cl1spd#
Global cl2spd#
Global cl3spd#
Global wt
Global ht
Global x
Global y
;\\\   \\\   \\\   \\\   \\\   \\\   \\\   \\\   \\\
;	Tex's global
;\\\   \\\   \\\   \\\   \\\   \\\   \\\   \\\   \\\
Global t1
Global t2
Global t3
Global t4
Global t5
Global t6
Global clr
;+ + + + + + + + + + + + + + + + +
;		TYPESSSSSssssssss
;+ + + + + + + + + + + + + + + + +
Type til
	Field tile
	Field x
	Field y
	Field pic
End Type

;- - - - - - - - - - - - - - - - - - - - - - - - -
;	funct. CALLER
;- - - - - - - - - - - - - - - - - - - - - - - - -
tileloader()
creation()
Text 0,100,"Loading . . . "
ld()
tgen()
;- - - - - - - - - - - - - - - - - - - - - - - - -
;	LOOOOOOOOOOPER
;- - - - - - - - - - - - - - - - - - - - - - - - -
While Not KeyDown(1)
drawme()
Wend
;- - - - - - - - - - - - - - - - - - - - - - - - -
;	LOOOOOOOOOOPER END
;- - - - - - - - - - - - - - - - - - - - - - - - -
Dim t(1,1)
Dim p(1,1)
End

;--------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------
;					FUNCTIONS
;--------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------

;- - - - - - - - - - - - - - - - - - - - - - - - -
;		CREATOR
;- - - - - - - - - - - - - - - - - - - - - - - - -
Function creation()
HidePointer
pl=LoadSprite("media\pok.png",4)
ScaleSprite pl,0.5,0.5
cam=CreateCamera(pl)
lit=CreateLight(1,cam)
fone=CreatePlane()
temptex=LoadTexture("media\fone1.jpg")
ScaleTexture temptex,0.5,0.5
EntityTexture fone,temptex
FreeTexture temptex
PositionEntity cam,0,0,-7
RotateEntity fone,270,0,0
TranslateEntity fone,0,0,5
PositionEntity pl,5,3,0

End Function
;========================
;	LEVEL	LOADER
;========================
Function ld()
lod=ReadFile("media\levs\dl1.sgl")
wt=ReadInt(lod)
ht=ReadInt(lod)
Dim t(wt,ht)
Dim p(wt,ht)
For i1=1 To wt
For i2=1 To ht
	t(i1,i2)=ReadInt(lod)
If t(i1,i2)=0 p(i1,i2)=-1
If t(i1,i2)=1 p(i1,i2)=0
If t(i1,i2)=2 p(i1,i2)=0
If t(i1,i2)=3 p(i1,i2)=0
If t(i1,i2)=4 p(i1,i2)=-1
If t(i1,i2)=5 p(i1,i2)=-1
If t(i1,i2)=6 p(i1,i2)=0
Next
Next
	CloseFile lod
End Function
;- - - - - - - - - - - - - - - - - - - - - - - - - -
;	TILE LOADER
;- - - - - - - - - - - - - - - - - - - - - - - - - -
Function tileloader()
;	BLOCK tiles
t1=LoadSprite("media\tiles\tile1.png",4) PositionEntity t1,10,10,-10
t2=LoadSprite("media\tiles\tile2.png",4) PositionEntity t2,10,10,-10
t3=LoadSprite("media\tiles\tile3.png",4) PositionEntity t3,10,10,-10
t4=LoadSprite("media\tiles\tile4.png",4) PositionEntity t4,10,10,-10
t5=LoadSprite("media\tiles\tile5.png",4) PositionEntity t5,10,10,-10
t6=LoadSprite("media\tiles\tile6.png",4) PositionEntity t6,10,10,-10
clr=LoadSprite("media\tiles\clear.png",4) PositionEntity clr,10,10,-10
;	TREE tiles
End Function
;- - - - - - - - - - - - - - - - - - - - - - - - -
;		controller
;- - - - - - - - - - - - - - - - - - - - - - - - -
Function control()
;- - - - - - - - - - - - - - - - - - - - - - - - -
If KeyHit(200)=True And jump#=0 Then jump#=1
If jump#>0
jump#=jump#-0.05 
Else 
jump#=0
EndIf
;- - - - - - - - - - - - - - - - - - - -
If KeyDown(205)=True
	If xmov<200
	xmov=xmov+10
	EndIf
Else
	If xmov>-2
	xmov=xmov-5
	EndIf
EndIf
;- - - - - - - - - - - - - - - - - - - -
If KeyDown(203)=True
	If xmov>-200
	xmov=xmov-10
	EndIf
Else
	If xmov<2
	xmov=xmov+5
	EndIf
EndIf


;- - - - - - - - - - - - - - - - - - - -
;----------PROVERKA PO "X"
;- - - - - - - - - - - - - - - - - - - -
TranslateEntity pl,xmov*0.001,0,0
x=EntityX(pl)+Sgn(xmov)-0.5*Sgn(xmov)
y=EntityY(pl)
;proverka na to, svobodna li kletka,kuda hotim peremestitsa
If p(x,y)>-1 TranslateEntity pl,-xmov*0.001,0,0
;- - - - - - - - - - - - - - - - - - - -
;----------PROVERKA PO "Y"
;- - - - - - - - - - - - - - - - - - - -
TranslateEntity pl,0,G#+jump#,0
x=EntityX(pl)
y=EntityY(pl)+Sgn(G#+jump#)-0.75*Sgn(G#+jump#)
;proverka na to, svobodna li kletka,kuda hotim peremestitsa
If p(x,y)>-1 TranslateEntity pl,0,-(G#+jump#),0
;	A eto dabi ne bulo lagov s visotoj:
x=EntityX(pl)
y=EntityY(pl)
If p(x,y-1)>-1 And (EntityY(pl)-y)<0.45 PositionEntity pl,EntityX(pl),y,EntityZ(pl)
End Function
;- - - - - - - - - - - - - - - - - - - - - - - - -
;		DRAWER
;- - - - - - - - - - - - - - - - - - - - - - - - -
Function drawme()

control()

MoveMouse GraphicsWidth()*0.5,GraphicsHeight()*0.5
RenderWorld
Text 0,0,xmov*0.001
Text 0,20,jump#
;Text 0,60,EntityX(pl)
;Text 0,80,EntityY(pl)
Text 0,60,x
Text 0,80,y
Flip
End Function
;-------------------------------------------------------------------------------
;		TILE GENERATOR
;-------------------------------------------------------------------------------
Function tgen()
For i1=1 To wt
For i2=1 To ht
	ti.til=New til
	ti\x=i1
	ti\y=i2
	ti\pic=t(i1,i2)
If ti\pic=0 ti\tile=CreateSprite() HideEntity ti\tile
If ti\pic=1 ti\tile=CopyEntity(t1)
If ti\pic=2 ti\tile=CopyEntity(t2)
If ti\pic=3 ti\tile=CopyEntity(t3)
If ti\pic=4 ti\tile=CopyEntity(t4)
If ti\pic=5 ti\tile=CopyEntity(t5)
If ti\pic=6 ti\tile=CopyEntity(t6)
	PositionEntity ti\tile,ti\x,ti\y,0.01
	ScaleSprite ti\tile,0.5,0.5
Next
Next
End Function